/*
linphone
Copyright (C) 2000  Simon MORLAT (simon.morlat@free.fr)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

typedef struct audio_buffer
{
  char *abuffer;
  int wr_ptr;
  int rd_ptr;
} audio_buffer_t;


#define N_BUFS 20

int audio_alsa_init();
int audio_oss_init();
int audio_loopback_init();
int audio_iodisk_init();

/* select device: for alsa or oss means soundcard, but this is not implemented for the moment.
for iodisk, means path to the file to read and the file where incoming audio can be written*/
extern int (*select_device)(char *in_name,char *out_name);
/*open dsp*/
extern int (*open_dsp)(int rate,int channel,int bits,int bsize);
extern int (*close_dsp)();
/* select recording source: 'm'=micro 'l'=line*/
extern int (*set_source)(char source);
/* set input level. lev is in 0-100 range.*/
extern int (*set_in_level)(int lev);
/* set output level.*/
extern int (*set_out_level)(int lev);
/* get a pointer to a buffer when data can be read.*/
extern char* (*get_read_audio_buffer)(void);
/* get a pointer to a buffer where data can be written for playing.*/
extern char* (*get_write_audio_buffer)(void);

